<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * class for import
 * 
 * Copyright-Hinweis:
 * Vorlage des Quellcodes ist das Import-Addon von Sebastian Arndt.
 * siehe: http://www.der-domi.de/board/viewtopic.php?t=11
 * siehe: tools/import-addon_by_sebastian_arndt.tar.gz
 */

class import {
    
    var $importTypes;       // include all possible databases
    var $importDB;          // include the online-database
    var $importID;          // ID which can imported from database
    var $varToImport;       // all variables which can be imported
    
    var $searchResult;
    
    var $url;
    var $buf1;
    var $buf2;
    var $buf3;
    var $siteBuf;
    var $loadBuf;
    
    
    function import() {
        
        $this->importTypes = array( "OFDB", "IMDB" );
        //$this->importTypes = array( "IMDB", "OFDB" ); // replace this line with above: set IMDB as default
        if ( array_key_exists( 'importDB', $_GET ) )
            $this->importType = $_GET['importDB'];
        
        $this->searchResult = array();
        $this->varToImport = array();
    }
    
    /*
     * search for a given string in OFDB
     * save all results in array
     */
    function ofdbsearch() {
        
        if ( !strlen($_GET["searchText"]) )
            return -1;
        
        // url to get search result
        $this->url = $this->getLinkToDB( urlencode(utf8_encode($_GET["searchText"])), FALSE, TRUE );
        
        if ( loadFile( $this->url, $this->buf1, "r" ) >= 0 ) {
            
            $this->buf2 = explode( "</i><br><br>1.", $this->buf1 );
            $this->buf1 = $this->buf2[1];
            $this->buf2 = explode( "<br><br><br>", $this->buf1 );

            $this->buf1 = $this->buf2[0];

            $this->buf2 = explode( "<a href=\"film/", $this->buf1 );
		
            for ( $i=0; $i<count($this->buf2) && $i<25; ++$i ) {
                
                $pattern = "#[0-9]*\.\s<a href=\"film/|\"\sonmouseover.*\)\">|<font size=\"1\">\ /\s|</font>\s\(|\)</a>#";
                $this->buf1 = preg_split ($pattern, trim ($this->buf2[$i]), -1, PREG_SPLIT_NO_EMPTY );
                
              
                $this->searchResult[$i] = array();
                $this->searchResult[$i]['title'] =  utf8_decode( $this->buf1[1] );
                $this->searchResult[$i]['id'] =  substr(utf8_decode ( $this->buf1[0] ),0,strpos(utf8_decode ( $this->buf1[0] ),','));
                $this->searchResult[$i]['year'] =  $this->buf1[3];
                
                if ( $this->buf1[2] != $this->buf1[1] )
                    $this->searchResult[$i]['alt'] =  utf8_decode ( $this->buf1[2] );
                else
                    $this->searchResult[$i]['alt'] =  "";
            }
            array_shift($this->searchResult);
            //print_r($this->searchResult); 
        }
    }
    
    /*
     * search for a given string in IMDB
     * save all results in array
     */
    function imdbsearch()
    {        
        if ( !strlen($_GET["searchText"]) )
            return -1;
        
        // url to get search result
        $this->url = $this->getLinkToDB( urlencode($_GET["searchText"]."*"), FALSE, TRUE );
        
        if ( loadFile( $this->url, $this->buf1, "r" ) >= 0 )
        {
            // delete duplicate "identifier"
            $this->buf1 = str_replace( "<b>Images from&nbsp;<a href=\"/title/", "", $this->buf1 );
            
            // search results for movies and save to array
            $this->buf2 = explode( "<a href=\"/title/", $this->buf1 );
            $this->buf1 = ""; // clear temporary buffer
            
            // get all movie-informations for all results
            // ignore first element becase this doesn't include results
            for ( $i=1; $i<count($this->buf2); ++$i )
            {
            	/* trim result */
                
                // get position of </td></tr>
                $needle = "</td></tr>";
                $pos = strpos($this->buf2[$i], $needle);
                // delete $needle and follow string
                $this->buf2[$i] = substr( $this->buf2[$i], 0, $pos );
                
                /* possible resultsets:
                    tt0119395/">The Jackal</a> (1997)<br>&#160;aka <em>"Schakal, Der"</em> - Austria, Germany</td></tr>
                    tt0068902/">Mala ordina, La</a> (1972)<br>&#160;aka <em>"Mafia Bo&#223;: Sie t&#246;ten wie Schakale, Der"</em> - Germany</td></tr><tr>
                    tt0120038/">Rote Schakal, Der</a> (1997) (TV)</td></tr>
                    tt0121720/">Schakaladu</a> (1984)</td></tr><tr> <td valign="top"><a href="/rg/photo-find/title-tiny/title/tt0187781/"><img src="http://ia.imdb.com/media/imdb/01/I/28/88/60/10t.jpg" width="23" height="32" border="0"></a>&nbsp;</td><td align="right" valign="top"><img src="/images/b.gif" width="1" height="6"><br>4.</td><td valign="top"><img src="/images/b.gif" width="1" height="6"><br>
                    tt0102158/">Jidao zhuizhong</a> (1991)<br>&#160;aka <em>"Zodiac Killer"</em><br>&#160;aka <em>"Zodiac Killers"</em>
            	 */
                /*
                    <b>Bilder aus&nbsp;<a href="/title/tt0119395/">The Jackal</a> (1997)</b>&nbsp;<a href="/rg/photo-find/title-gallery//gallery/granitz/0328-the/Events/0328-the/simmons1.ene.html?path=gallery&path_key=0119395">Alle 9 Photos/Fotos anzeigen</a>
<table cellspacing="1" cellpadding="0"><tr><td><a href="/rg/photo-find/title-top//gallery/ss/0119395/Ss/0119395/iid_1026806.jpg.html?path=gallery&path_key=0119395"><img src="http://ia.imdb.com/media/imdb/01/I/60/86/20/10p.jpg"  width="125"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/wittkata.rin.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-wittkata.rin"  width="58"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/willisb1.uce.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-willisb1.uce"  width="57"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/willisb2.uce.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-willisb2.uce"  width="59"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/willisbr.uce.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-willisbr.uce"  width="60"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/moore_de.mi.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-moore_de.mi"  width="62"  height="90"  border="1"></a></td><td>
<a href="/rg/photo-find/title-top//gallery/granitz/0328-the/Events/0328-the/bissettj.ack.html?path=gallery&path_key=0119395"><img src="http://i.imdb.com/Photos/Events/0328-the/th-bissettj.ack"  width="56"  height="90"  border="1"></a></td>
</tr></table> <p><b>Meistgesuchte Titel</b> (2 Ergebnisse werden angezeigt)<table><tr> <td valign="top"><a href="/rg/photo-find/title-tiny/title/tt0119395/"><img src="http://ia.imdb.com/media/imdb/01/I/54/70/83/10t.jpg" width="23" height="32" border="0"></a>&nbsp;</td><td align="right" valign="top"><img src="/images/b.gif" width="1" height="6"><br>1.</td><td valign="top"><img src="/images/b.gif" width="1" height="6"><br>
<a href="/title/tt0119395/">The Jackal</a> (1997)<br>&#160;alternativ: <em>"The Day of the Jackal"</em> - USA <em>(working title)</em></td></tr><tr> <td valign="top"><a href="/rg/photo-find/title-tiny/title/tt0069947/"><img src="http://ia.imdb.com/media/imdb/01/I/99/09/06t.jpg" width="23" height="32" border="0"></a>&nbsp;</td><td align="right" valign="top"><img src="/images/b.gif" width="1" height="6"><br>2.</td><td valign="top"><img src="/images/b.gif" width="1" height="6"><br><a href="/title/tt0069947/">The Day of the Jackal</a> (1973)</td></tr></table> </p> <p><b>Titel (genaue bereinstimmung)</b> (3 Ergebnisse werden angezeigt)<table><tr> <td valign="top"><a href="/rg/photo-find/title-tiny/title/tt0118647/"><img src="http://ia.imdb.com/media/imdb/01/I/55/56/80/10t.jpg" width="23" height="32" border="0"></a>&nbsp;</td><td align="right" valign="top"><img src="/images/b.gif" width="1" height="6"><br>1.</td><td valign="top"><img src="/images/b.gif" width="1" height="6"><br><a href="/title/tt0118647/">The Assignment</a> (1997)<br>&#160;alternativ: <em>"Jackal"</em> - USA <em>(working title)</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">2.</td><td valign="top"><a href="/title/tt0369596/">Jackal</a> (1986) (VG)</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">3.</td><td valign="top"><a href="/title/tt0011361/">Kaksen p&#229; &#216;verland</a> (1920)<br>&#160;alternativ: <em>"Jackal"</em> - <em>(English title)</em> <em>(wide-release title)</em></td></tr></table> </p> <p><b>Titel (teilweise bereinstimmung)</b> (11 Ergebnisse werden angezeigt)<table><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">1.</td><td valign="top"><a href="/title/tt0064147/">Chacal de Nahueltoro, El</a> (1969)<br>&#160;alternativ: <em>"Jackal of Nahueltoro"</em> - USA</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">2.</td><td valign="top"><a href="/title/tt0066240/">Prega il morto e ammazza il vivo</a> (1971)<br>&#160;alternativ: <em>"To Kill a Jackal"</em> - USA</td></tr><tr> <td valign="top"><a href="/rg/photo-find/title-tiny/title/tt0098831/"><img src="http://ia.imdb.com/media/imdb/01/I/80/90/34t.jpg" width="23" height="32" border="0"></a>&nbsp;</td><td align="right" valign="top"><img src="/images/b.gif" width="1" height="6"><br>3.</td><td valign="top"><img src="/images/b.gif" width="1" height="6"><br><a href="/title/tt0098831/">The Rose and the Jackal</a> (1990) (TV)</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">4.</td><td valign="top"><a href="/title/tt0282799/">Layali ibn awa</a> (1988)<br>&#160;alternativ: <em>"Jackal Nights"</em> - USA <em>(cable TV title)</em><br>&#160;alternativ: <em>"The Night of the Jackal"</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">5.</td><td valign="top"><a href="/title/tt0436557/">The Making of 'The Jackal'</a> (1998) (V)</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">6.</td><td valign="top"><a href="/title/tt0131492/">The Mummy and the Curse of the Jackals</a> (1969)<br>&#160;alternativ: <em>"Mummy's Curse of the Jackal"</em><br>&#160;alternativ: <em>"The Mummy vs. the Were-Jackal"</em> - USA <em>(working title)</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">7.</td><td valign="top"><a href="/title/tt0371533/">Amor chacal</a> (2002)<br>&#160;alternativ: <em>"Jackal Love"</em> - USA <em>(informal English title)</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">8.</td><td valign="top"><a href="/title/tt0186090/">The Fearless Jackal</a> (1982)</td></tr><tr> <td 
valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">9.</td><td valign="top"><a href="/title/tt0369537/">History's Mysteries: Carlos the Jackal</a> (2001) (TV)</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">10.</td><td valign="top"><a href="/title/tt0281451/">&#34;Jackal and Hide&#34;</a> (1987)</td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">11.</td><td valign="top"><a href="/title/tt1049409/">The Prince, the Pimp, the Jackal and the Spayed</a> (2007)</td></tr></table> </p> <p><b>Namen (teilweise bereinstimmung)</b> (4 Ergebnisse werden angezeigt)<table><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">1.</td><td valign="top"><a href="/name/nm0413127/">Joanne Jackal</a>  <small>(Actress, <a href="/title/tt0257101/">Savage Hunt</a> (1980))</small></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">2.</td><td valign="top"><a href="/name/nm0413146/">Ian Jacklin</a>  <small>(Actor, <a href="/title/tt0109576/">Death Match</a> (1994))</small><br>&#160;Spitzname <em>"The Jackal"</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">3.</td><td valign="top"><a href="/name/nm0130535/">Don Callis</a>  <small>(Actor, <a href="/title/tt0264563/">ECW: Anarchy Rulz</a> (2000) (VG))</small><br>&#160;Spitzname <em>"The Jackal"</em></td></tr><tr> <td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">4.</td><td valign="top"><a href="/name/nm1666202/">Jan Ove Ottesen</a>  <small>(Self, <a href="/title/tt0609917/">&#34;III nach neun: (2005-12-02)&#34;</a> (2005))</small><br>&#160;Spitzname <em>"The Jackal"</em></td></tr></table> </p> <p><b>Rollen (teilweise bereinstimmung)</b> (1 Ergebnis wird angezeigt)<table><tr>  <td valign="top"><img src="http://i.imdb.com/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">1.</td><td valign="top"><a href="/character/ch0009503/">The Jackal</a> <small>(<a href="/title/tt0119395/">The Jackal</a> (1997), <a href="/name/nm0000246/">Bruce Willis</a>)</small></td></tr></table> </p> <p><b>Firmen (teilweise bereinstimmung)</b> (3 Ergebnisse werden angezeigt)<table><tr>

<td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">1.</td><td valign="top"><a href="/company/co0007684/">Hungry Jackal Productions</a> [us] (Production)</td></tr><tr>
<td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">2.</td><td valign="top"><a href="/company/co0151533/">Jackal Pictures</a> [gb] (Production)</td></tr><tr>
<td valign="top"><img src="/images/b.gif" alt="" width="23" height="1"></td><td align="right" valign="top">3.</td><td valign="top"><a href="/company/co0211797/">Jackal Productions</a> [us] (Production)</td></tr></table> </p>
                 */
                
                // find delimiter /"> - get title
                $pattern = "\/\">(&#34;){0,1}|" .
                // find delimiter </a> ( - get year
                    "(&#34;){0,1}<\/a> \(|" .
                // find delimiter ) (|) - end; or get alternative infos
                    "(\) \([a-zA-Z]+\)|\))|" .
                // find delimiter <em>" - get alternative title
                    " <em>\"|" .
                // find delimiter "</em> - get country
                    "\"<\/em>( - |<br>)|" .
                // find delimiter  <em>|</td> - end
                    "( <em>|<\/td>)";
                
                
                // format pattern string
                $pattern = "/" . $pattern . "/";
                $string_array = preg_split ($pattern, trim ($this->buf2[$i]), -1, PREG_SPLIT_NO_EMPTY );

                // Leere Eintrge aus Suchergebniss lschen
                if (empty($string_array) == 1) {
                unset($string_array);
                } else {

                   // fill results
                   $this->tmp_searchResult[$i-1] = array();
                   $this->tmp_searchResult[$i-1]['title'] =  $string_array[1];
                   $this->tmp_searchResult[$i-1]['id'] =  $string_array[0];
                   $this->tmp_searchResult[$i-1]['year'] =  $string_array[2];
                
                   if ( count($string_array) >= 6 )
                   {
                       // if alternativ name longer than 70 letter, there is an error
                       if ( strlen($string_array[4]) < 70 )
                           $this->tmp_searchResult[$i-1]['alt'] =  $string_array[4];
//                     $this->tmp_searchResult[$i-1]['alt'] .=  " - ".$string_array[5]; // country
                   }
                   else
                       $this->tmp_searchResult[$i-1]['alt'] =  "";
                }
            }
            //fehlerhafte Nummerierung des Arrays beheben
            $this->searchResult = array_values($this->tmp_searchResult);
        }
    }
    
    function ofdbimport( &$myVar) {
        
        if ( !strlen($_GET["importID"]) )
            return -1;
        
        $this->importID = $_GET['importID'];
        $this->FassungID = $_GET['fassungID'];
        
        
        // url to get search result
        $this->url = ret_entities( $this->getLinkToDB( $this->importID ) );
        
        if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
            
            // Titel
            $search = "<h2><font face=\"Arial,Helvetica,sans-serif\" size=\"3\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font></h2></td>', $this->buf1[1] );
            $this->varToImport['title'] = htmlentities( utf8_decode( $this->buf2[0] ) );
            
            // url
            $this->varToImport['url'] = htmlentities( $this->url );
            
            // Originaltitel
            $search = '<td width="99%"><font face="Arial,Helvetica,sans-serif" size="2" class="Daten"><b>';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font></td>', $this->buf1[1] );
            $this->varToImport['original_title'] = htmlentities( utf8_decode ($this->buf2[0] ) );
            
            // Land
            $search = '<a href="view.php?page=blaettern&Kat=Land&Text=';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->varToImport['land'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i ) {
                
                $this->buf2 = explode( '"', $this->buf1[$i] );
	        $this->varToImport['land'][$i-1] = htmlentities( utf8_decode (urldecode ($this->buf2[0] ) ) );
            }
            
            // Jahr
            $search = '<a href="view.php?page=blaettern&Kat=Jahr&Text=';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '"', $this->buf1[1] );
            $this->varToImport['year'] = $this->buf2[0];
            
            // Genres
            $search = '<a href="view.php?page=genre&Genre=';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->varToImport['genres'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i ) {
                
                $this->buf2 = explode( '"', $this->buf1[$i] );
                $this->varToImport['genres'][$i-1] = htmlentities( utf8_decode (urldecode( $this->buf2[0] ) ) );
            }
            
            // Cover
	    	$search = 'http://img.ofdb.de/film/';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '"', $this->buf1[1] );
            if ( $this->buf2[0] != "na.gif" )
                $this->varToImport['cover'] = "http://img.ofdb.de/film/".$this->buf2[0];
            
            // Versionen (Fassungen)
            $search = '<a href="view.php?page=fassung&fid='.$this->importID.'&vid=';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->varToImport['versions'] = array();
	    $var = $myVar->getRequest("");
            for ( $i=1; $i<count($this->buf1); ++$i ) {
                
                $this->buf2 = explode( '">', $this->buf1[$i] );
                $this->varToImport['versions'][$i-1] = array();
                $this->varToImport['versions'][$i-1]['Importlink'] = $_SERVER['PHP_SELF']."?".$var . 'importDB='.$this->importType.'&amp;importID='.$this->importID.'&amp;fassungID='.$this->buf2[0];
                $this->varToImport['versions'][$i-1]['Fassungslink'] = "http://www.ofdb.de/view.php?page=fassung&amp;fid=".$this->importID."&amp;vid=".$this->buf2[0];
                $this->varToImport['versions'][$i-1]['FassungsID'] = $this->buf2[0];
                
                $this->buf2 = explode( '</a></b>', $this->buf2[1] );
                $this->varToImport['versions'][$i-1]['name'] = htmlentities( utf8_decode (urldecode( $this->buf2[0] ) ) );
            }
            
            // FSK
      			$search = "Freigabe: ";
      			// ..."DVD: 20th Century Fox (Best of Fox), Freigabe: FSK 16","55,98 EUR"
                  $this->buf1 = explode( $search, $this->siteBuf );
                  $this->buf2 = explode( '"', $this->buf1[1] );
                  list ($textFsk, $fsk, $rest) = explode( ' ', $this->buf2[0] );
      			//echo "--- FSK: $textFsk=$fsk<br>";

      			if ($textFsk == "FSK")
      			{
      				if ($fsk == "o.A.")
      					$this->varToImport['fsk'] = "0";
      				else if ($fsk == "Keine")
      					$this->varToImport['fsk'] = "18";
      				else if (is_numeric ($fsk))
      					$this->varToImport['fsk'] = $fsk;
      				else 
      					$this->varToImport['fsk'] = "";		// error!
      			}
      			elseif ($textFsk == "SPIO/JK:")
      			{
              if ($fsk == "keine")
      			     $this->varToImport['fsk'] = "18";
      			  else
      			     $this->varToImport['fsk'] = "";
      			}
      			else	// FSK unbekannt
      				$this->varToImport['fsk'] = "";
            
            // Inhalt
            $search = '<a href="plot/';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '">', $this->buf1[1] );
            //http://www.ofdb.de/plot/22784,29083,Stargate-Kommando-SG-1
            $this->url = "http://www.ofdb.de/plot/".$this->buf2[0];
            if ( $this->buf2[0] && loadFile( $this->url, $this->loadBuf, "r" ) >= 0 ) {

                $search = '</b><br><br>';
                $this->buf1 = explode( $search, $this->loadBuf );
                $this->buf2 = explode( '</font></p>', $this->buf1[1] );
                $this->varToImport['inhalt'] = utf8_decode($this->buf2[0]);
            }
            
            
            // url to get search result (CAST)
            $this->url = "http://www.ofdb.de/view.php?page=film_detail&fid=$this->importID";
            
            if ( loadFile( $this->url, $this->loadBuf, "r" ) >= 0 )
            {
                // Schauspieler
                $search = "<b><i>Darsteller</i></b>";
                $this->buf1 = explode( $search, $this->loadBuf );
                $this->buf2 = explode( "</table>", $this->buf1[1] );
                $search = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
                $this->buf1 = explode( $search, $this->buf2[0] );
                
                $search = "<tr valign=\"middle\">";
                $this->buf2 = explode( $search, $this->buf1[1] );
                for ( $i=1; $i<count($this->buf2); ++$i )
                {
                    $this->buf1 = explode( "&nbsp;&nbsp;", strip_tags( $this->buf2[$i] ) );
                    $this->varToImport['actors'][$i-1] =  htmlentities( utf8_decode ( trim( $this->buf1[1] ) ) ) ;
                    
                    /* *** get moviename from actor ***
                    $this->buf1 = htmlentities( trim( $this->buf1[2] ) );
                    $this->buf1 = str_replace( "... ", "", $this->buf1 );
                    $this->varToImport['actors_alias'][$i-1] = $this->buf1;
                    */
                }
                
                // Regisseure
                $search = "<b><i>Regie</i></b>";
                $this->buf1 = explode( $search, $this->loadBuf );
                $this->buf2 = explode( "</table>", $this->buf1[1] );
                $search = "<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
                $this->buf1 = explode( $search, $this->buf2[0] );
                
                $search = "<tr valign=\"middle\">";
                $this->buf2 = explode( $search, $this->buf1[1] );
                for ( $i=1; $i<count($this->buf2); ++$i )
                {
                    $this->buf1 = explode( "&nbsp;&nbsp;", strip_tags( $this->buf2[$i] ) );
                    $this->varToImport['regisseure'][$i-1] = htmlentities( utf8_decode ( trim( $this->buf1[1] ) ) );
                    
                    /* *** get informations from regie ***
                    $this->buf1 = htmlentities( trim( $this->buf1[2] ) );
                    $this->buf1 = str_replace( "... ", "", $this->buf1 );
                    $this->varToImport['regisseure_alias'][$i-1] = $this->buf1;
                    */
                }
            }
        }

if($this->FassungID) {
        $this->url = 'http://www.ofdb.de/view.php?page=fassung&fid='.$this->importID.'&vid='.$this->FassungID;

        if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {

            // FassungsLink
            $this->varToImport['furl'] = $this->url;

            // Bildformat
            $search = "Bildformat:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
        
            $this->buf3 = explode( '(', $this->buf2[0] );
            $this->varToImport['Bildformat'] = trim(utf8_decode($this->buf3[0]));
            $this->varToImport['Aufloesung'] = str_replace(')','',utf8_decode($this->buf3[1]));
            if($this->varToImport['Aufloesung'] == 'anamorph / 16:9') {
               $this->varToImport['Aufloesung'] = '576p';
            }


            // Untertitel
            $search = "Untertitel:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
            $this->buf3 = explode( '<br>', $this->buf2[0] );

            for ( $i=0; $i<count($this->buf3); ++$i ) {
              if (strpos($this->buf3[$i],'</b>') === FALSE) {
                $this->varToImport['Untertitel'][$i] = html_entity_decode($this->buf3[$i]);
              }
            }


            // Tonformat
            $search = "Tonformat:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</a><br></b></font></td></tr>', $this->buf1[1] );
            $this->buf3 = explode( '">', $this->buf2[0] );                       
            
            for ( $i=1; $i<count($this->buf3); ++$i ) {
                $this->buf1 = explode( ')', $this->buf3[$i] );
                $this->buf2 = explode( '(', $this->buf1[0] );
        	      $this->varToImport['Sprache'][$i-1] = utf8_decode($this->buf2[0]);            
                $this->varToImport['Tonformat'][$i-1] = utf8_decode($this->buf2[1]);
            }

            // Laufzeit einlesen
            $search = "Laufzeit:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font></td></tr>', $this->buf1[1] );
            list ($min, $sek, $rest) = explode( ':', $this->buf2[0] );
            list ($sek, $rest, $rest2) = explode( ' Min', $sek );

            if($sek > 30) {
              $min = $min +1;
            }
            $this->varToImport['Laufzeit'] = $min;

            // EAN einlesen
            $search = "EAN/UPC</a>:</font></td><td></td><td><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b>', $this->buf1[1] );
            $this->varToImport['EAN'] = utf8_decode( $this->buf2[0] );

            // Format - wenn kein Logo vorhanden
            $search = "Erscheinungsart:</font></td><td>&nbsp;&nbsp;&nbsp;</td><td width=\"99%\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\" class=\"Daten\"><b>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</b></font><br>', $this->buf1[1] );
            $this->varToImport['Format'] = utf8_decode( $this->buf2[0] );

            // Format - wenn Logo vorhanden
            if(empty($this->buf2[0])) {
               $search = ">Erscheinungsart:</font></td><td>&nbsp;&nbsp;&nbsp;</td><td width=\"99%\"><img src=\"";
               $this->buf1 = explode( $search, $this->siteBuf );
               $this->buf1 = explode( "<font size=\"1\" face=\"Arial, Helvetica, sans-serif\" style=\"font-size: 10px; vertical-align: top;\">&nbsp;&nbsp;&nbsp;" ,$this->buf1[1]);
               $this->buf2 = explode( '</font><br><img ', $this->buf1[1] );
               $this->varToImport['Format'] = utf8_decode( $this->buf2[0] );
            }


            // FSK - bereits erkannte FSK freigabe sichern
            $fsk = $this->varToImport['fsk'];
            
            // nun erst nach Freigabe ohne FSK suchen
            $search = ")\">SPIO/JK: ";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</a></b></font></td></tr>', $this->buf1[1] );
            
            if($this->buf2[0] == "keine schwere Jugendgef&auml;hrdung") {
              $this->varToImport['fsk'] = 18;  
            } else {
            
              // Nichts gefunden, dann normale FSK freigabe suchen
              $search = ")\">FSK ";
              $this->buf1 = explode( $search, $this->siteBuf );
              $this->buf2 = explode( '</a></b></font></td></tr>', $this->buf1[1] );
  
              if ($this->buf2[0] == "o.A.")
                 $this->varToImport['fsk'] = "0";
              else if ($this->buf2[0] == "Keine Jugendfreigabe")
                 $this->varToImport['fsk'] = "18";
              else if (is_numeric ($this->buf2[0]))
                 $this->varToImport['fsk'] = $this->buf2[0];
              else 
                 $this->varToImport['fsk'] = "$fsk";		// error!
            }
        }
        }
    }
    
    function imdbimport( &$myVar ) {
        
        if ( !strlen($_GET["importID"]) )
            return -1;
        
        $this->importID = $_GET['importID'];
        
        // url to get search result
        $this->url = ret_entities( $this->getLinkToDB( $this->importID ) );
        
        if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 ) {
            
            // Titel
            $search = "<h1>";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( ' <span>', $this->buf1[1] );
            $this->varToImport['title'] = $this->buf2[0];
            
            // url
            $this->varToImport['url'] = $this->url;
            
            // Jahr
            $search = "<a href=\"/Sections/Years/";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '"', $this->buf1[1] );
            $this->varToImport['year'] = $this->buf2[0];
            
            // Land
            $search = '<h5>Produktionsland:</h5>';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</div>', $this->buf1[1] );
            $search = '/">';
            $this->buf1 = explode( $search, $this->buf2[0] );
            $this->varToImport['land'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i )
            {
                $this->buf2 = explode( '</a>', $this->buf1[$i] );
                $this->varToImport['land'][$i-1] = urldecode( $this->buf2[0] );
            }
            
            // Laufzeit
            $search = "<h5>L&auml;nge:</h5>\n";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( ' min', $this->buf1[1] );
            $this->varToImport['laufzeit'] = $this->buf2[0];
            
            // FSK
            $search = "Germany:";
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '&', $this->buf1[1] );
            $this->varToImport['fsk'] = $this->buf2[0];
            
            // Cover
            $search = '<div class="photo">';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</div>', $this->buf1[1] );
            $search = 'src="';
            $this->buf1 = explode( $search, $this->buf2[0] );
            $this->varToImport['cover'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i )
            {
                $this->buf2 = explode( '" />', $this->buf1[$i] );
                $this->varToImport['cover'][$i-1] = urldecode( $this->buf2[0] );
            }
            
            // Genres
            $search = '<a href="/Sections/Genres/';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->varToImport['genres'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i ) {
                
                $this->buf2 = explode( '/"', $this->buf1[$i] );
                $this->varToImport['genres'][$i-1] = urldecode( $this->buf2[0] );
            }
            
            // Regisseure
            $search = '<div class="info">';
            $this->buf1 = explode( $search, $this->siteBuf );
            $this->buf2 = explode( '</div>', $this->buf1[1] );
            $search = '/">';
            $this->buf1 = explode( $search, $this->buf2[0] );
            $this->varToImport['regisseure'] = array();
            for ( $i=1; $i<count($this->buf1); ++$i )
            {
                $this->buf2 = explode( '</a>', $this->buf1[$i] );
                $this->varToImport['regisseure'][$i-1] = urldecode( $this->buf2[0] );
            }

            $tmpBuf = $this->siteBuf;
            // get position of </td></tr>
            $needle = '<table class="cast">';
            $pos = strpos($tmpBuf, $needle);
            // delete $needle and follow string
            $tmpBuf = substr( $tmpBuf, $pos );
            $needle = '</table>';
            $pos = strpos($tmpBuf, $needle);
            // delete $needle and follow string
            $tmpBuf = substr( $tmpBuf, 0, $pos );
            
	    // Actors
	    $pattern = '<a href="\/name\/nm[0-9]+\/">|' .
            '<\/a><\/td><td class="ddd">';
            $pattern = "/" . $pattern . "/";
            $string_array = preg_split( $pattern, trim($tmpBuf), -1, PREG_SPLIT_NO_EMPTY );
            
            for ( $i=1; $i<count($string_array)-1; $i=$i+2 )
            {
                $this->varToImport['actors'][] = $string_array[$i];
            }

            
            // Inhalt
            $this->url = $this->url . "plotsummary";
            if ( loadFile( $this->url, $this->siteBuf, "r" ) >= 0 )
            {
                
                $search = '<p class="plotpar">';
                $this->buf1 = explode( $search, $this->siteBuf );
                $this->varToImport['inhalt'] = "";
                for ( $i=1; $i<count($this->buf1); ++$i ) 
                {
                    $this->buf2 = explode( '</p>', $this->buf1[$i] );
                    if ( !substr_count( $this->buf2[0], "http://ia.imdb.com/media/imdb/" ) )
                        $this->buf2[0] = strip_tags($this->buf2[0],'');
                        $this->varToImport['inhalt'] = htmlentities( urldecode( $this->buf2[0] ) );
                }
            }
        }
    }
    
    
    function getData( $data )
    {
        if ( array_key_exists( $data, $this->varToImport ) )
        {
            if ( !is_array( $this->varToImport[$data] ) )
                return $this->varToImport[$data];
            
            $ret = "";
            
            for ( $i=0; $i<count($this->varToImport[$data]); $i++ )
            {
                if ( $i != 0 )
                    $ret .= ", ";
                
                if ( $data != "versions" )
                    $ret .= trim( $this->varToImport[$data][$i] );
                else
                    $ret .= "<a href=\"{$this->varToImport[$data][$i]['Importlink']}\">{$this->varToImport[$data][$i]['name']}</a><a href=\"{$this->varToImport[$data][$i]['Fassungslink']}\" target=\"_blank\"> - (OFDB: {$this->varToImport[$data][$i]['FassungsID']})</a>";
            }
            return $ret;
        }
        else
            return "";
    }
    
    
    function printSearchResult(&$myVar) {
    	
        $var = $myVar->getRequest(""); 
        
        echo "<ul style=\"list-style-image: url(./img/list.gif); margin: 0em; padding: 0.8em 0 0 2em; vertical-align: top; font-family:Tahoma; font-size:0.82em;\">";
        for ( $i=0; $i<count($this->searchResult); ++$i ) {
            
            echo "<li>";
            $link = $_SERVER['PHP_SELF']."?".$var . "importDB=$this->importType&amp;importID={$this->searchResult[$i]['id']}";
            echo "(" . $this->searchResult[$i]['year']. ") <a href=\"$link\"><u>" .$this->searchResult[$i]['title'] . "</u></a>";
            
            if ( strlen($this->searchResult[$i]['alt']) )
                echo " (alternativ: ".$this->searchResult[$i]['alt'].")";
            
            echo $this->getLinkToDB( $this->searchResult[$i]['id'], TRUE );
            echo "</li>";
        }
        echo "</ul>";
    }
    
    
    function getLinkToDB( $id, $asHyperref=FALSE, $search=FALSE )
    {
        if ( FALSE==$search )
        {
            if ( $this->importTypes[$this->importType] == "OFDB" )
              //  $link = "http://www.ofdb.de/film/$id";
                  $link = "http://www.ofdb.de/view.php?page=film&fid=$id";
            elseif ( $this->importTypes[$this->importType] == "OFDB_XML") 
                $link = "http://xml.n4rf.net/ofdbgw/movie/$id";
            else
                $link = "http://german.imdb.com/title/$id/";
        }
        else // get link to search
        {
            if ( $this->importTypes[$this->importType] == "OFDB" )
                $link = "http://www.ofdb.de/view.php?page=suchergebnis&SText=" . $id . "&Kat=Titel";
            elseif ( $this->importTypes[$this->importType] == "OFDB_XML")
                $link = 'http://xml.n4rf.net/ofdbgw/search_ext/'. urlencode(utf8_encode($id)).'.xml';
            else
                $link = "http://german.imdb.com/find?q=" . $id . ";s=tt";
        }
        
        if ( TRUE==$asHyperref )
        {
            $link = " <a href=\"$link\" target=\"_blank\">(";
            $link .= $this->importTypes[$this->importType] .": $id";
            $link .= ")</a>";
        }
        
        return $link;
    }
    
    
    function printImportID( &$myVar )
    {
        $var = array();
        $var = $myVar->getRequest($var,TRUE); 
        
        echo "<form style=\"display: inline;\" method=\"get\" name=\"importID\" action=\"{$_SERVER['PHP_SELF']}\">";
        echo $var;
        echo "<table>";
        echo "<tr>";
        echo "<td style=\"vertical-align:top;\">";
        echo "<select style=\"border: 1px solid #999999; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; font-style: normal; line-height: 12px; color: black; clear: none; float: none; width: 100px; background-color: #FFFFFF;\" name=\"importDB\">";
        for ( $i=0; $i<count($this->importTypes); ++$i ) {
            echo "<option value=\"$i\" ";
            if ( array_key_exists("importDB", $_GET) && $_GET['importDB'] == $i )
            echo "selected=\"selected\"";
            echo ">{$this->importTypes[$i]}</option>";
        }
        echo "</select>";
        echo "</td>";   
        echo "<td style=\"vertical-align:top;\">";       
        echo "<input type=\"text\" style=\"border: 1px solid #999999; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; font-style: normal; line-height: 12px; color: black; clear: none; float: none; width: 100px; background-color: #FFFFFF;\" name=\"importID\" value=\"";
        if ( array_key_exists("importID", $_GET) )
            echo $_GET['importID'];
        echo "\" />";
        echo "</td>";
        echo "<td style=\"vertical-align:middle;\">";
        echo "<input type=\"image\" style=\"display: block;\"  src=\"./img/import.gif\" name=\"sent\" value=\"\" />";
        echo "</td>";
        echo "<td style=\"vertical-align:botton; padding: 0px 0px 0px 10px;\">";
        echo "<span onmouseover=\"toolTip(' &lt;table align=\'left\' width=\'100%\'>&lt;tr&gt;&lt;td width=\'50%\'&gt;&lt;u&gt;OFDB Import&lt;/u&gt;&lt;br/&gt;&lt;ul&gt;&lt;li&gt;einfach die ID des Films&lt;/li&gt;&lt;li&gt;Beispiel von Titanic:&lt;br&gt;227&lt;/li&gt;&lt;/ul&gt;&lt;/td&gt;&lt;td width=\'50%\'&gt;&lt;u&gt;IMDB Import&lt;/u&gt;&lt;br/&gt;&lt;ul&gt;&lt;li&gt;einfach die ID des Films&lt;/li&gt;&lt;li&gt;Beispiel von Titanic:&lt;br&gt;tt0120338&lt;/li&gt;&lt;/ul&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt; ')\"  onmouseout=\"toolTip()\" ><img src=\"./img/hilfe.gif\" style=\"display: block;\" alt=\"Hilfe\" /></span> ";
        echo "</td>";
        echo "</tr>";
        echo "</table>";
        echo "</form>";
    }
    
    function printSearch( &$myVar )
    {
        $var = array();
        $var = $myVar->getRequest($var,TRUE); 
        
        echo "<form style=\"display: inline;\" method=\"get\" name=\"search\" action=\"{$_SERVER['PHP_SELF']}\">";
        echo $var;
        echo "<table>";
        echo "<tr>";
        echo "<td style=\"vertical-align:top;\">";
        echo "<select style=\"border: 1px solid #999999; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; font-style: normal; line-height: 12px; color: black; clear: none; float: none; width: 100px; background-color: #FFFFFF;\" name=\"importDB\">";
        for ( $i=0; $i<count($this->importTypes); ++$i ) {
            echo "<option value=\"$i\" ";
            if ( array_key_exists("importDB", $_GET) && $_GET['importDB'] == $i )
            echo "selected=\"selected\"";
            echo ">{$this->importTypes[$i]}</option>";
        }
        echo "</select>";
        echo "</td>";
        echo "<td style=\"vertical-align:top;\">";        
        echo "<input type=\"text\" style=\"border: 1px solid #999999; font-family: Verdana,Arial,Helvetica,sans-serif; font-size: 10px; font-style: normal; line-height: 12px; color: black; clear: none; float: none; width: 100px; background-color: #FFFFFF;\" name=\"searchText\" value=\"";
        if ( array_key_exists("searchText", $_GET) )
            echo $_GET['searchText'];
        echo "\" />";
        echo "</td>";
        echo "<td style=\"vertical-align:middle;\">";
        echo "<input type=\"image\"  style=\"display: block;\"  src=\"./img/suchen.gif\" name=\"sent\" value=\"\" />";
        echo "</td>";
        echo "<td style=\"vertical-align:botton; padding: 0px 0px 0px 10px;\">";
        echo "<span onmouseover=\"toolTip(' &lt;table align=\'left\' width=\'100%\'>&lt;tr&gt;&lt;td width=\'50%\'&gt;&lt;u&gt;OFDB Suche&lt;/u&gt;&lt;br/&gt;&lt;ul&gt;&lt;li&gt;komplett in deutsch&lt;/li&gt;&lt;li&gt;Anzeige von Versionen&lt;br&gt;und Fassungen (DVDs, Videos, Kino)&lt;/li&gt;&lt;li&gt;genauer Suchbegriff erforderlich&lt;/li&gt;&lt;/ul&gt;&lt;/td&gt;&lt;td width=\'50%\'&gt;&lt;u&gt;IMDB Suche&lt;/u&gt;&lt;br/&gt;&lt;ul&gt;&lt;li&gt;noch in englisch&lt;/li&gt;&lt;li&gt;FSK und Laufzeit werden automatisch importiert&lt;/li&gt;&lt;li&gt;kein genauer Suchbegriff erforderlich&lt;/li&gt;&lt;br/&gt;&lt;/ul&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt; ')\"  onmouseout=\"toolTip()\" ><img src=\"./img/hilfe.gif\" style=\"display: block;\" alt=\"Hilfe\" /></span> ";
        echo "</td>";
        echo "</tr>";
        echo "</table>";
        echo "</form>";
    }
    

    function isGenre( $genre )
    {
        $ret = FALSE;
        
        if ( is_array($this->varToImport['genres']) )
        {
            if ( in_array( $genre, $this->varToImport['genres'] ) )
                $ret = TRUE;
        }
        
        return $ret;
    }

    function loadFile( $url, &$buf )
    {
    	$buf = "";
        
        require_once('./classes/class.HttpRequest.php');
        $request = new HTTPRequest($url);
        $buf = $request->DownloadToString();
        
        return strlen($buf);
    }
}

?>
